Debian Bug report logs - #333468
'aptitude changelog' can't deal with binNMU'ed packages

version graph

Package: aptitude; Maintainer for aptitude is Aptitude Development Team <aptitude-devel@lists.alioth.debian.org>; Source for aptitude is src:aptitude.

Reported by: LI Daobing <lidaobing@gmail.com>

Date: Wed, 12 Oct 2005 02:48:03 UTC

Severity: normal

Tags: patch

Merged with 422064, 422311, 432439

Found in versions aptitude/0.2.15.9-6, aptitude/0.4.4-4, aptitude/0.4.5.4-1

Fixed in version aptitude/0.4.11.3-1

Done: Daniel Burrows <dburrows@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, lidaobing@gmail.com, Daniel Burrows <dburrows@debian.org>:
Bug#333468; Package aptitude. Full text and rfc822 format available.

Acknowledgement sent to LI Daobing <lidaobing@gmail.com>:
New Bug report received and forwarded. Copy sent to lidaobing@gmail.com, Daniel Burrows <dburrows@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: LI Daobing <lidaobing@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: 'aptitude changelog' can't deal with version a.b.c.0.1
Date: Wed, 12 Oct 2005 10:44:50 +0800
Package: aptitude
Version: 0.2.15.9-6
Severity: normal

$ dpkg -l dpkg | grep ^ii
ii  dpkg           1.13.11.0.1    package maintenance system for Debian
$ aptitude changelog dpkg
Ign ChangeLog of dpkg
E: Couldn't fetch URL http://packages.debian.org/changelogs/pool/main/d/dpkg/dpkg_1.13.11.0.1/changelog
W: /home/nichloas/.aptitude/.tmp/aptitudegGIuBz - unlink (2 No such file or directory)
E: Couldn't find a changelog for dpkg

-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.12-1-686-smp
Locale: LANG=en_US.UTF-8, LC_CTYPE=zh_CN.UTF-8 (charmap=UTF-8)

Versions of packages aptitude depends on:
ii  apt [libapt-pkg-libc6.3-6-3.1 0.6.41     Advanced front-end for dpkg
ii  libc6                         2.3.5-6    GNU C Library: Shared libraries an
ii  libgcc1                       1:4.0.2-2  GCC support library
ii  libncurses5                   5.4-8      Shared libraries for terminal hand
ii  libsigc++-1.2-5c2             1.2.5-5    type-safe Signal Framework for C++
hi  libstdc++6                    4.0.2-2    The GNU Standard C++ Library v3

Versions of packages aptitude recommends:
pn  aptitude-doc-en | aptitude-do <none>     (no description available)

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#333468; Package aptitude. Full text and rfc822 format available.

Acknowledgement sent to Daniel Burrows <dburrows@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #10 received at 333468@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dburrows@debian.org>
To: LI Daobing <lidaobing@gmail.com>, 333468@bugs.debian.org
Subject: Re: Bug#333468: 'aptitude changelog' can't deal with version a.b.c.0.1
Date: Thu, 13 Oct 2005 11:57:50 -0700
[Message part 1 (text/plain, inline)]
  There are a lot of weird corner cases where the source and binary
versions differ (as is currently the case for dpkg).  aptitude doesn't
attempt to cover them all.

  The proper solution would be for the binary package to contain a
reference to its source version.  I've heard through the grapevine
that this proper solution is planned in the future, so I'm not really
interested in cramming short-term hacks into aptitude to cover this
situation.

  Daniel
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#333468; Package aptitude. Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <sven_joachim@web.de>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. Full text and rfc822 format available.

Message #15 received at 333468@bugs.debian.org (full text, mbox):

From: Sven Joachim <sven_joachim@web.de>
To: 333468@bugs.debian.org
Subject: Re: Bug#333468: 'aptitude changelog' can't deal with version a.b.c.0.1
Date: Mon, 30 Apr 2007 09:35:54 +0200
found 333468 0.4.4-4
thanks

On Thu, 13 Oct 2005 11:57:50 -0700, Daniel Burrows wrote:

>  There are a lot of weird corner cases where the source and binary
> versions differ (as is currently the case for dpkg).  aptitude doesn't
> attempt to cover them all.

>  The proper solution would be for the binary package to contain a
> reference to its source version.  I've heard through the grapevine
> that this proper solution is planned in the future, so I'm not really
> interested in cramming short-term hacks into aptitude to cover this
> situation.

FWIW, this seems to have been implemented in the meantime, packages
that are binNMU'ed do have a Source: field in the control file.
Aptitude should use that field to construct the URL of the changelog.
Can you implement this, Daniel?

Cheers,

Sven



Bug marked as found in version 0.4.4-4. Request was from Sven Joachim <sven_joachim@web.de> to control@bugs.debian.org. (Mon, 30 Apr 2007 07:45:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#333468; Package aptitude. Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. Full text and rfc822 format available.

Message #22 received at 333468@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: 333468@bugs.debian.org
Subject: 'aptitude changelog' for binNMU'ed packages (was: 'aptitude changelog' can't deal with version a.b.c.0.1)
Date: Mon, 28 Apr 2008 19:41:17 +0200
retitle 333468 'aptitude changelog' can't deal with binNMU'ed packages
tags 333468 + patch
thanks

On 2007-04-30 09:35 +0200, Sven Joachim wrote:

> On Thu, 13 Oct 2005 11:57:50 -0700, Daniel Burrows wrote:
>
>>  There are a lot of weird corner cases where the source and binary
>> versions differ (as is currently the case for dpkg).  aptitude doesn't
>> attempt to cover them all.
>
>>  The proper solution would be for the binary package to contain a
>> reference to its source version.  I've heard through the grapevine
>> that this proper solution is planned in the future, so I'm not really
>> interested in cramming short-term hacks into aptitude to cover this
>> situation.
>
> FWIW, this seems to have been implemented in the meantime, packages
> that are binNMU'ed do have a Source: field in the control file.
> Aptitude should use that field to construct the URL of the changelog.
> Can you implement this, Daniel?

No progress on this bug in the last year, and I just couldn't stand this
"Couldn't fetch URL..." any more.  While I'm not familiar enough with
the aptitude source (nor with C++, for that matter) to implement a
proper solution that uses the Source: field, at least I have a (tested!)
patch that deals with the current scheme of binNMU names:

--8<---------------cut here---------------start------------->8---
diff -r b9df1dc55acd src/generic/apt/pkg_changelog.cc
--- a/src/generic/apt/pkg_changelog.cc	Wed Apr 23 19:54:20 2008 -0700
+++ b/src/generic/apt/pkg_changelog.cc	Mon Apr 28 19:23:56 2008 +0200
@@ -138,6 +138,8 @@
       realver.assign(ver, ver.find(':')+1, ver.npos);
     else
       realver = ver;
+    if(realver.rfind("+b") == realver.length()-3)
+      realver.erase(realver.length()-3);
 
     uri = ssprintf("http://packages.debian.org/changelogs/pool/%s/%s/%s/%s_%s/changelog",
 		   realsection.c_str(),
--8<---------------cut here---------------end--------------->8---

If you think this is too much of a hack, feel free to remove the patch
tag.  But since the binNMU naming scheme is quite established and
unlikely to change soon, it may at least represent a mid-term solution
until somebody┬╣ comes up with a better design.

Cheers,
       Sven


┬╣ s/somebody/Daniel Burrows/ would come nearer to the truth. ;-)




Changed Bug title to `'aptitude changelog' can't deal with binNMU'ed packages' from `'aptitude changelog' can't deal with version a.b.c.0.1'. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Mon, 28 Apr 2008 17:54:03 GMT) Full text and rfc822 format available.

Tags added: patch Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Mon, 28 Apr 2008 17:54:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#333468; Package aptitude. Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. Full text and rfc822 format available.

Message #31 received at 333468@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: 333468@bugs.debian.org
Subject: Merging bugs
Date: Sun, 11 May 2008 18:36:38 +0200
package aptitude
forcemerge 333468 422064
thanks

Now I see that this issue had been reported several times, merging the
bugs accordingly.  I think "normal" is the better severity here.

Sven




Forcibly Merged 333468 422064 422311 432439. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Sun, 11 May 2008 16:51:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#333468; Package aptitude. Full text and rfc822 format available.

Acknowledgement sent to Daniel Burrows <dburrows@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #38 received at 333468@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dburrows@debian.org>
To: Sven Joachim <svenjoac@gmx.de>, 333468@bugs.debian.org
Subject: Re: Bug#333468: 'aptitude changelog' for binNMU'ed packages (was: 'aptitude changelog' can't deal with version a.b.c.0.1)
Date: Sat, 17 May 2008 10:35:31 -0700
On Mon, Apr 28, 2008 at 07:41:17PM +0200, Sven Joachim <svenjoac@gmx.de> was heard to say:
> No progress on this bug in the last year, and I just couldn't stand this
> "Couldn't fetch URL..." any more.  While I'm not familiar enough with
> the aptitude source (nor with C++, for that matter) to implement a
> proper solution that uses the Source: field, at least I have a (tested!)
> patch that deals with the current scheme of binNMU names:

  I was a little puzzled by this, because I had a vague recollection
that it was fixed.  It turns out that it's been fixed for ages, but only
at the command-line, and even there it was maked by #480533, which
broke all sorts of changelog stuff in interesting ways.  The fix is
pretty trivial now that apt exports the source version of a package in
its API, so I'll go apply it.

  Daniel




Forcibly Merged 333468 422064 422311 432439. Request was from Daniel Burrows <dburrows@debian.org> to control@bugs.debian.org. (Sat, 17 May 2008 17:54:44 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#333468; Package aptitude. Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. Full text and rfc822 format available.

Message #45 received at 333468@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: Daniel Burrows <dburrows@debian.org>
Cc: 333468@bugs.debian.org
Subject: Re: Bug#333468: 'aptitude changelog' for binNMU'ed packages
Date: Sat, 17 May 2008 19:59:10 +0200
On 2008-05-17 19:35 +0200, Daniel Burrows wrote:

> On Mon, Apr 28, 2008 at 07:41:17PM +0200, Sven Joachim <svenjoac@gmx.de> was heard to say:
>> No progress on this bug in the last year, and I just couldn't stand this
>> "Couldn't fetch URL..." any more.  While I'm not familiar enough with
>> the aptitude source (nor with C++, for that matter) to implement a
>> proper solution that uses the Source: field, at least I have a (tested!)
>> patch that deals with the current scheme of binNMU names:
>
>   I was a little puzzled by this, because I had a vague recollection
> that it was fixed.  It turns out that it's been fixed for ages, but only
> at the command-line, and even there it was maked by #480533, which
> broke all sorts of changelog stuff in interesting ways.

I don't quite understand this, bug #480533 seems to be unrelated.
Probably you mean some other bug?

>  The fix is
> pretty trivial now that apt exports the source version of a package in
> its API, so I'll go apply it.

Sven




Reply sent to Daniel Burrows <dburrows@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to LI Daobing <lidaobing@gmail.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #50 received at 333468-close@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dburrows@debian.org>
To: 333468-close@bugs.debian.org
Subject: Bug#333468: fixed in aptitude 0.4.11.3-1
Date: Tue, 27 May 2008 05:32:04 +0000
Source: aptitude
Source-Version: 0.4.11.3-1

We believe that the bug you reported is fixed in the latest version of
aptitude, which is due to be installed in the Debian FTP archive:

aptitude-dbg_0.4.11.3-1_i386.deb
  to pool/main/a/aptitude/aptitude-dbg_0.4.11.3-1_i386.deb
aptitude-doc-cs_0.4.11.3-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-cs_0.4.11.3-1_all.deb
aptitude-doc-en_0.4.11.3-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-en_0.4.11.3-1_all.deb
aptitude-doc-fi_0.4.11.3-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-fi_0.4.11.3-1_all.deb
aptitude-doc-fr_0.4.11.3-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-fr_0.4.11.3-1_all.deb
aptitude-doc-ja_0.4.11.3-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-ja_0.4.11.3-1_all.deb
aptitude_0.4.11.3-1.diff.gz
  to pool/main/a/aptitude/aptitude_0.4.11.3-1.diff.gz
aptitude_0.4.11.3-1.dsc
  to pool/main/a/aptitude/aptitude_0.4.11.3-1.dsc
aptitude_0.4.11.3-1_i386.deb
  to pool/main/a/aptitude/aptitude_0.4.11.3-1_i386.deb
aptitude_0.4.11.3.orig.tar.gz
  to pool/main/a/aptitude/aptitude_0.4.11.3.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 333468@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Burrows <dburrows@debian.org> (supplier of updated aptitude package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Mon, 26 May 2008 21:25:26 -0700
Source: aptitude
Binary: aptitude aptitude-dbg aptitude-doc-cs aptitude-doc-en aptitude-doc-fi aptitude-doc-fr aptitude-doc-ja
Architecture: source all i386
Version: 0.4.11.3-1
Distribution: unstable
Urgency: low
Maintainer: Daniel Burrows <dburrows@debian.org>
Changed-By: Daniel Burrows <dburrows@debian.org>
Description: 
 aptitude   - terminal-based package manager
 aptitude-dbg - Debug symbols for the aptitude package manager
 aptitude-doc-cs - Czech manual for aptitude, a terminal-based package manager
 aptitude-doc-en - English manual for aptitude, a terminal-based package manager
 aptitude-doc-fi - Finnish manual for aptitude, a terminal-based package manager
 aptitude-doc-fr - French manual for aptitude, a terminal-based package manager
 aptitude-doc-ja - Japanese manual for aptitude, a terminal-based package manager
Closes: 333468 475740 476344 476732 476749 476835 476837 477165 477295 480062 480063 480533 481007 481458
Changes: 
 aptitude (0.4.11.3-1) unstable; urgency=low
 .
   * New upstream release.
 .
     - "aptitude unhold" should work now. (Closes: #477165)
 .
     - Fixed almost complete breakage of "aptitude changelog". (Closes: #481458)
 .
     - Fixed retrieving the changelogs of bin-nmued packages from the curses
       interface. (Closes: #333468)
 .
     - Always be at least as quiet as the user requested that we be.
       (Closes: #476749)
 .
     - Remove a stray hyphen in the output of --help. (Closes: #476835)
 .
     - Fix the manpage to talk about Recommends-Important instead of
       Install-Recommends. (Closes: #480533)
 .
     - Translation updates:
       * Brazilian Portuguese (Closes: #481007)
       * Danish (Closes: #476732)
       * French
       * Galician (Closes: #476837)
       * German (Closes: #476344)
       * Japanese
       * Norwegian Bokmal (Closes: #480063)
       * Polish (Closes: #480062)
       * Simplified Chinese (Closes: #475740)
       * Vietnamese (Closes: #477295)
Checksums-Sha1: 
 b270ad157453d8f2035487ec9dd4af367bf9c4dc 1382 aptitude_0.4.11.3-1.dsc
 86b6efce71f3a5fc2663e0729d6e1bf1a68077e7 5664563 aptitude_0.4.11.3.orig.tar.gz
 f014abb222ab31eba1f409d0617b8f5220ddf1c1 34921 aptitude_0.4.11.3-1.diff.gz
 22d945b681f117c9b1261b5a035011701793384d 344616 aptitude-doc-cs_0.4.11.3-1_all.deb
 b38d3148fe0ca12634c9a8ec30cd6aa5f16735d5 352134 aptitude-doc-en_0.4.11.3-1_all.deb
 3a66687fe4091e8cfc62b5c5391fff646c1ccef1 263082 aptitude-doc-fi_0.4.11.3-1_all.deb
 d64410f7c9d9d688652cfdd181f2ff93ec778a78 297042 aptitude-doc-fr_0.4.11.3-1_all.deb
 c3b092a924db6d6f75f4b8245cde32da80178317 362578 aptitude-doc-ja_0.4.11.3-1_all.deb
 ca72c69889a499fae0537363d5f213861e45362a 2837896 aptitude_0.4.11.3-1_i386.deb
 0c5443e1fbe4920a041e5032bc9db12b79e25eb8 6749638 aptitude-dbg_0.4.11.3-1_i386.deb
Checksums-Sha256: 
 7303f8a539492b0888aaf74d82de7ba44f01ae3ffddc0dca34639ff4ade32214 1382 aptitude_0.4.11.3-1.dsc
 cf9ed9b0087f669b0a16d068211660118f17f68c979451880753b95d4a57a6e3 5664563 aptitude_0.4.11.3.orig.tar.gz
 ee0d797baefb2809bc8f961bb2f774b4fa9bf0e0af92c6a15a2369b760e14c7c 34921 aptitude_0.4.11.3-1.diff.gz
 9a0ff8c4fc9ed7332cd87f92d9c6d6b9e7041b9c4c6a24d5bb0e240c04e44efc 344616 aptitude-doc-cs_0.4.11.3-1_all.deb
 c93481a19737d049a963abd9910d634487e40e8fe73534c98d89ab95413ae1b0 352134 aptitude-doc-en_0.4.11.3-1_all.deb
 a52f9b402b629401954888ac52f39f5235f75b07a51d25b99ac6f2cb4f530789 263082 aptitude-doc-fi_0.4.11.3-1_all.deb
 8d13ed90dd02e350ee227abe700c00b49a903307d7474eb4bc716f566eedbab2 297042 aptitude-doc-fr_0.4.11.3-1_all.deb
 c83f45e73ea0d15b590de06c31cad63d1fd6112e28da37968683292fdd979509 362578 aptitude-doc-ja_0.4.11.3-1_all.deb
 c2101de9b4110117dbe47556681f21c5e06c90fa943b2a8a18a4a6e5edc61ae1 2837896 aptitude_0.4.11.3-1_i386.deb
 de306d430effc4e3a56e9a881f6acc2037fc2c9720a41769cce0abc8fabf6540 6749638 aptitude-dbg_0.4.11.3-1_i386.deb
Files: 
 50725fb7256815550bda6e409543aab2 1382 admin - aptitude_0.4.11.3-1.dsc
 834eddf27d6c58454142f3ce5d73ee83 5664563 admin - aptitude_0.4.11.3.orig.tar.gz
 954f7aad7b1183f21f9686a2341ec021 34921 admin - aptitude_0.4.11.3-1.diff.gz
 c1ee3d1a199f8e2e357f526890e8ae62 344616 doc optional aptitude-doc-cs_0.4.11.3-1_all.deb
 3a186fc39565289556ceb545da585b33 352134 doc optional aptitude-doc-en_0.4.11.3-1_all.deb
 6c1c0eb5b75ba927cf7db049add26822 263082 doc optional aptitude-doc-fi_0.4.11.3-1_all.deb
 d2948b257523b03edd72c8d1d0f677aa 297042 doc optional aptitude-doc-fr_0.4.11.3-1_all.deb
 288f429d5e545c0f523ae65e4fea8c1b 362578 doc optional aptitude-doc-ja_0.4.11.3-1_all.deb
 9cd9def7c169fe088eb436fb9c370bd2 2837896 admin important aptitude_0.4.11.3-1_i386.deb
 98c2e231882bf0831db1b117574cc19f 6749638 devel extra aptitude-dbg_0.4.11.3-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFIO5vIch6xsM7kSXgRAmsNAJ9oYuR219IJXqUp8Cp7VI1UqchqNgCg8VET
LEjOmb/kA7Pg+udGOe8L8tM=
=J/T+
-----END PGP SIGNATURE-----





Reply sent to Daniel Burrows <dburrows@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Vladimir Suplin <vsuplin@gmail.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Reply sent to Daniel Burrows <dburrows@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Peter Samuelson <peter@p12n.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Reply sent to Daniel Burrows <dburrows@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Rogier <rogierg@12move.nl>:
Bug acknowledged by developer. Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 14 Oct 2009 07:30:42 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 04:06:27 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.